%===========ULAZNI PARAMETRI=============================================
N=10;        %broj tacaka dodira
H=20;        %visina
H1=15;       % visina odsecka
k=4;         %nije neophodno zadavati jer se izracunava
R=5;         %poluprecnik
R1=H1*R/H;   %poluprecnik odsecka
nn=[0 0 1];     %normala primitiva
np=[-1 0 0];  %supalj primitiv np=[1 0 0], pun primitiv np=[-1 0 0]
T=[1 0 0 0; 0 0 1 0; 0 -1 0 0; 0 0 0 1]; %sistema primitiva u odnosu na kordinatni sistem
                                         %radnog predmeta u
                                         %HOMOGENIM
                                         %KOORDINATAMA
%========================================================================

d2=0.4*R;    %put brzog hoda
d1=1/5*d2;   %put brzog hoda (mali krug)

for i = 1 : N
    i_n=i-1;
    brojac1 = 0;
    h(i)=i+(1-i);
    for j = 1 : k
        j_n = j - 1;
        number1 = i_n/(2^j_n);
        brojac1 = brojac1 + 1;
        number2(brojac1) = mod(number1,2)*2^(-j_n-1);
        
    end
    %disp (number1)
    %disp (number2)
    
    s_pom(i)=i_n/N;
    t_pom(i) =mod(sum(number2),1);
    
    s_prim(i)=R1+((1-t_pom(i))^0.5)*(R-R1);
    t_prim(i)=s_pom(i)*360;
    w_prim(i)=(R-s_prim(i))*H1/R1;
    
    s(i)=s_prim(i)*cos(t_prim(i)*pi/180);
    t(i)=s_prim(i)*sin(t_prim(i)*pi/180);
    w(i) =w_prim(i);
    
    %formiranje vektora O(i)
    s_o(i)=0;
    t_o(i)=0;
    w_o(i)=w(i);
    
    %formiranje vektora normale
    P=cross(nn,np);
    Py=P(1,2);
    if Py==-1;
        s_nor(i)=-1*(s_o(i)-s(i))/R;
        t_nor(i)=-1*(t_o(i)-t(i))/R;
        w_nor(i)=-1*(w_o(i)-w(i))/R;
    else
        s_nor(i)=(s_o(i)-s(i))/R;
        t_nor(i)=(t_o(i)-t(i))/R;
        w_nor(i)=(w_o(i)-w(i))/R;
    end
    
    n=[s_nor; t_nor; w_nor];
    
    %formiranje vektora PP1
    s_PP1(i)=s_nor(i)*d1;
    t_PP1(i)=t_nor(i)*d1;
    w_PP1(i)=w_nor(i)*d1;
    
    %formiranje vektora PP2
    s_PP2(i)=s_nor(i)*d2;
    t_PP2(i)=t_nor(i)*d2;
    w_PP2(i)=w_nor(i)*d2;
    
    
    s1(i)=s_PP1(i)+s(i);
    t1(i)=t_PP1(i)+t(i);
    w1(i)=w_PP1(i)+w(i);
    
    s2(i)=s_PP2(i)+s(i);
    t2(i)=t_PP2(i)+t(i);
    w2(i)=w_PP2(i)+w(i);
    
%     P=[s; t; w];
%     P1=[s1; t1; w1];
%     P2=[s2; t2; w2];
    
    %disp(i_n)
end
%HOMOGENE KOORDINATE
P=[s; t; w; h];
P1=[s1; t1; w1; h];
P2=[s2; t2; w2; h];

P=T*P;
P1=T*P1;
P2=T*P2;

%KOORDINATE TRANSFORMISANIH TACAKA

P(1,1:N)=P(1,:); %s
P(2,1:N)=P(2,:); %t
P(3,1:N)=P(3,:); %w

P1(1,1:N)=P1(1,:); %s1
P1(2,1:N)=P1(2,:); %t1
P1(3,1:N)=P1(3,:); %w1

P2(1,1:N)=P2(1,:); %s2
P2(2,1:N)=P2(2,:); %t2
P2(3,1:N)=P2(3,:); %w2

Xmo1=[P2(1,:); P1(1,:); P(1,:); P1(1,:)];
Ymo1=[P2(2,:); P1(2,:); P(2,:); P1(2,:)];
Zmo1=[P2(3,:); P1(3,:); P(3,:); P1(3,:)];

[m,o] = size(Xmo1);
for k=1:m;
    
    for j= 1 : o
        r=j*m;
        q=r-(m-1);
        Xmo(1,q:r)=Xmo1(:,j);
        Ymo(1,q:r)=Ymo1(:,j);
        Zmo(1,q:r)=Zmo1(:,j);
        
    end
end

Xmo
Ymo
Zmo
%trazene koordinate tacaka
disp P
disp (P)
disp Pi1
disp (P1)
disp Pi2
disp (P2)

%cone
[X,Y,Z] = cylinder(R1:0.25:R); %!!!!!!!!!!!!! nije najbolje resenje za prikaz zarubljene kupe!!!!
[mx, ox] = size(X);

for k=1:mx
    f(k)=k+(1-k);
    C(1,1:ox)=X(k,:);
    C(2,1:ox)=Y(k,:);
    C(3,1:ox)=Z(k,:);
    C(4,1:ox)=f(k);
    C=T*C;
    
    X(k,1:ox)=C(1,:);
    Y(k,1:ox)=C(2,:);
    Z(k,1:ox)=C(3,:);
    
end
if T(1,3)==1 
    X=(H-H1)-X*(H-H1);
elseif T(1,3)==-1
    X=((H-H1)-(H-H1)*X)-2*(H-H1);
elseif T(2,3)==1 
    Y=(H-H1)-Y*(H-H1);
elseif T(2,3)==-1
    Y=((H-H1)-(H-H1)*Y)-2*(H-H1);
elseif T(3,3)==1 
    Z=(H-H1)-Z*(H-H1);
elseif T(3,3)==-1
    Z=((H-H1)-(H-H1)*Z)-2*(H-H1);
else
    disp Z osa primitiva se ne poklapa sa  nekom od osa pravaca pristupa
end

testsubject = surf(X,Y,Z);
set(testsubject,'FaceAlpha',0.5,'EdgeColor','red','EdgeAlpha',0.6,...
    'DiffuseStrength',1,'AmbientStrength',1);
xlabel('x'); ylabel('y'); zlabel('z');
hold on
plot3(P1(1,:),P1(2,:),P1(3,:),'o','markerfacecolor','b','markeredgecolor','b')
hold on
plot3(P2(1,:),P2(2,:),P2(3,:),'o','markerfacecolor','red','markeredgecolor','red')
hold on
plot3(P(1,:),P(2,:),P(3,:),'o','markerfacecolor','black','markeredgecolor','black')
grid on
view(45,45)