function putanja_cylinder(Xmo, Ymo, Zmo)

% pre pokretanja funkcije kao putanja_F1(Xmo, Ymo, Zmo)
% treba definisati Xmo, Ymo i Zmo na sledeci nacin
% Xmo = [-2 5 8 5 0]; Ymo = [1 6 9 6 0]; Zmo = [2 7 8 7 10]. Ili uzeti kao
% izlaz iz nekog drugog programa ali formatirane kao ovo gore.

s = size(Xmo,2);

R=5;
H=20;
T=[1 0 0 0; 0 0 1 0; 0 -1 0 0; 0 0 0 1];

for i = 1 : s-1
    x1 = Xmo(i);
    y1 = Ymo(i);
    z1 = Zmo(i);
    
    x2 = Xmo(i+1);
    y2 = Ymo(i+1);
    z2 = Zmo(i+1);
    
    for p = 0:0.02:1
        
        xt = x1 + p*(x2-x1);
        yt = y1 + p*(y2-y1);
        zt = z1 + p*(z2-z1);
        
        figure (1)
        clf
        hold on
        grid on
        
        hold on
        [X,Y,Z] = cylinder(R,100);
        C(1,:)=X(1,:)
        C(2,:)=Y(1,:);
        C(3,1:101)=0;
        C(4,1:101)=1;
        
        C1(1,:)=X(2,:);
        C1(2,:)=Y(2,:);
        C1(3,1:101)=H;
        C1(4,1:101)=1;
        
        TC=T*C;
        TC1=T*C1;
        
        X(1,:)=TC(1,:);
        X(2,:)=TC1(1,:);
        Y(1,:)=TC(2,:);
        Y(2,:)=TC1(2,:);
        Z(1,:)=TC(3,:);
        Z(2,:)=TC1(3,:);
        X;
        Y;
        Z;
        testsubject = surf(X,Y,Z);
        set(testsubject,'FaceAlpha',0.5,'EdgeColor','red','EdgeAlpha',0.6,...
            'DiffuseStrength',1,'AmbientStrength',1)
        hold on
        
        plot3(Xmo,Ymo,Zmo,'-o','MarkerSize',5,'markerfacecolor','black','markeredgecolor','black')
        plot3(xt,yt,zt,'o','MarkerSize',10,'markerfacecolor','red','markeredgecolor','red')
        view(45,45)
    end
end

