function putanja_plane(Xmo, Ymo, Zmo)

% pre pokretanja funkcije kao putanja_F1(Xmo, Ymo, Zmo)
% treba definisati Xmo, Ymo i Zmo na sledeci nacin
% Xmo = [-2 5 8 5 0]; Ymo = [1 6 9 6 0]; Zmo = [2 7 8 7 10]. Ili uzeti kao
% izlaz iz nekog drugog programa ali formatirane kao ovo gore.

s = size(Xmo,2);
    
a=20;
b=20;
T=[0 0 1 95; 1 0 0 0; 0 1 0 -75; 0 0 0 1];

 p1 = [0; 0; 0; 1];
 p2 = [a; 0; 0; 1];
 p3 = [a; b; 0; 1];
 p4 = [0; b; 0; 1];
 
 p1=T*p1;
 p2=T*p2;
 p3=T*p3;
 p4=T*p4;
 
 x = [p1(1) p2(1) p3(1) p4(1)];
 y = [p1(2) p2(2) p3(2) p4(2)];
 z = [p1(3) p2(3) p3(3) p4(3)];
 
for i = 1 : s-1
    x1 = Xmo(i);
    y1 = Ymo(i);
    z1 = Zmo(i);
    
    x2 = Xmo(i+1);
    y2 = Ymo(i+1);
    z2 = Zmo(i+1);
    
    for p = 0:0.02:1
        
        xt = x1 + p*(x2-x1);
        yt = y1 + p*(y2-y1);
        zt = z1 + p*(z2-z1);
        
        figure (1)
        clf
        hold on
        grid on
        
        fill3(x, y, z, 1);
        xlabel('x'); ylabel('y'); zlabel('z');
        hold on
        
        
        plot3(Xmo,Ymo,Zmo,'-o','MarkerSize',5,'markerfacecolor','black','markeredgecolor','black')
        plot3(xt,yt,zt,'o','MarkerSize',10,'markerfacecolor','red','markeredgecolor','red')
        view(45,45)
    end
end

