function putanja_sphere_zar(Xmo, Ymo, Zmo)

% pre pokretanja funkcije kao putanja_F1(Xmo, Ymo, Zmo)
% treba definisati Xmo, Ymo i Zmo na sledeci nacin
% Xmo = [-2 5 8 5 0]; Ymo = [1 6 9 6 0]; Zmo = [2 7 8 7 10]. Ili uzeti kao
% izlaz iz nekog drugog programa ali formatirane kao ovo gore.

s = size(Xmo,2);

R=5;
H1=2;
R1=(2*H1*R-(H1^2))^0.5;
T=[1 0 0 0; 0 0 1 0; 0 -1 0 0; 0 0 0 1];

[X,Y,Z] = sphere(100);
[mx, ox] = size(X);

for k=1:mx
    f(k)=k+(1-k);
    C(1,1:ox)=X(k,:);
    C(2,1:ox)=Y(k,:);
    C(3,1:ox)=Z(k,:);
    C(4,1:ox)=f(k);
    C=T*C;
    
    X(k,1:ox)=C(1,:);
    Y(k,1:ox)=C(2,:);
    Z(k,1:ox)=C(3,:);
    
end
X=X*R;
Y=Y*R;
Z=Z*R;
if T(1,3)==1
    X(find(X<=0))=NaN;
    X(find(X>=R-H1))=NaN;
elseif T(1,3)==-1
    X(find(X>=0))=NaN;
    X(find(X<=R-H1))=NaN;
elseif T(2,3)==1
    Y(find(Y<=0))=NaN;
    Y(find(Y>=R-H1))=NaN;
elseif T(2,3)==-1
    Y(find(Y>=0))=NaN;
    Y(find(Y<=R-H1))=NaN;
elseif T(3,3)==1
    Z(find(Z<=0))=NaN;
    Z(find(Z>=R-H1))=NaN;
elseif T(3,3)==-1
    Z(find(Z>=0))=NaN;
    Z(find(Z<=R-H1))=NaN;
else
    disp Z osa primitiva se ne poklapa sa  nekom od osa pravaca pristupa
end

for i = 1 : s-1
    x1 = Xmo(i);
    y1 = Ymo(i);
    z1 = Zmo(i);
    
    x2 = Xmo(i+1);
    y2 = Ymo(i+1);
    z2 = Zmo(i+1);
    
    for p = 0:0.02:1
        
        xt = x1 + p*(x2-x1);
        yt = y1 + p*(y2-y1);
        zt = z1 + p*(z2-z1);
        
        figure (1)
        clf
        hold on
        grid on
        
        testsubject = surf(X,Y,Z);
        set(testsubject,'FaceAlpha',0.5,'EdgeColor','red','EdgeAlpha',0.6,...
            'DiffuseStrength',1,'AmbientStrength',1)
        xlabel('x'); ylabel('y'); zlabel('z');
        hold on
        plot3(Xmo,Ymo,Zmo,'-o','MarkerSize',5,'markerfacecolor','black','markeredgecolor','black')
        plot3(xt,yt,zt,'o','MarkerSize',10,'markerfacecolor','red','markeredgecolor','red')
        view(45,45)
    end
end

