%==========ULAZNI PARAMETRI==============================================
N=10;       %broj tacaka dodira
a=1;
b=1;       %dimenzije
k=log2 (N);        %Hemerslejev koeficijent (izracunava se)
n=[0 0 1];  %normala
%T=[nx ny nz 0; ox oy oz 0; ax ay az 0;px py pz 1];  %pozicija i orjentacija koordinatnog 
T=[1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1];            %sistema primitiva u odnosu na kordinatni sistem 
                                                     %radnog predmeta u
                                                     %HOMOGENIM KOORDINATAMA
%========================================================================

d2=1;      %put brzog hoda
d1=1/3*d2;  %put radnog hoda

PP1=n*d1;
PP2=n*d2;

for i = 1 : N
    i_n=i-1;
    si=i_n/N;
    brojac1 = 0;
    h(i)=i+(1-i);
    for j = 1 : k
        j_n = j - 1;
        number1 = i_n/(2^j_n);
        brojac1 = brojac1 + 1;
        number2(brojac1) = mod(number1,2)*2^(-j_n-1);
                
    end
    %disp (i_n)
    s(i)=si*a;
    t(i)=mod(sum(number2),1)*b;
    w(i) =si*0;
    
    
    s1(i)=PP1(:,1)+s(i);
    t1(i)=PP1(:,2)+t(i);
    w1(i)=PP1(:,3)+w(i);
    
    
    s2(i)=PP2(:,1)+s(i);
    t2(i)=PP2(:,2)+t(i);
    w2(i)=PP2(:,3)+w(i);
   
    
%     P=[s; t; w];
%     P1=[s1; t1; w1];
%     P2=[s2; t2; w2];
    

end
    %HOMOGENE KOORDINATE
    P=[s; t; w; h];
    P1=[s1; t1; w1; h];
    P2=[s2; t2; w2; h];

    P=T*P;
    disp(' P = ')
    disp(P)
    P1=T*P1;
    disp(P1)
    disp(' P1 = ')
    P2=T*P2;
    disp(P2)
    disp(' P2 = ')
    
    %KOORDINATE TRANSFORMISANIH TACAKA
    
    P(1,1:N)=P(1,:); %s
    P(2,1:N)=P(2,:); %t
    P(3,1:N)=P(3,:); %w
  
    P1(1,1:N)=P1(1,:); %s1
    P1(2,1:N)=P1(2,:); %t1
    P1(3,1:N)=P1(3,:); %w1
      
    P2(1,1:N)=P2(1,:); %s2
    P2(2,1:N)=P2(2,:); %t2
    P2(3,1:N)=P2(3,:); %w2
                
    Xmo1=[P2(1,:); P1(1,:); P(1,:); P1(1,:)];
    Ymo1=[P2(2,:); P1(2,:); P(2,:); P1(2,:)];
    Zmo1=[P2(3,:); P1(3,:); P(3,:); P1(3,:)];
    

    
    [m,o] = size(Xmo1);
for k=1:m;
        
    for j= 1 : o
        r=j*m;
        q=r-(m-1);
        Xmo(1,q:r)=Xmo1(:,j);
        Ymo(1,q:r)=Ymo1(:,j);
        Zmo(1,q:r)=Zmo1(:,j);

    end
end

    Xmo;
    Ymo;
    Zmo;
    disp P
    disp (P)
    disp P1
    disp (P1)
    disp P2
    disp (P2)

%plane
 p1 = [0; 0; 0; 1];
 p2 = [a; 0; 0; 1];
 p3 = [a; b; 0; 1];
 p4 = [0; b; 0; 1];
 
 p1=T*p1;
 p2=T*p2;
 p3=T*p3;
 p4=T*p4;
 
 x = [p1(1) p2(1) p3(1) p4(1)];
 y = [p1(2) p2(2) p3(2) p4(2)];
 z = [p1(3) p2(3) p3(3) p4(3)];

hFig = figure(1);

fill3(x, y, z, [0.9 0.4 0.2]);
hold on

plot3(P1(1,:),P1(2,:),P1(3,:),'o','markersize',4.5,'markerfacecolor','b','markeredgecolor','b')
hold on
plot3(P2(1,:),P2(2,:),P2(3,:),'o','markersize',4.5,'markerfacecolor','red','markeredgecolor','red')
hold on
plot3(P(1,:),P(2,:),P(3,:),'o','markersize',4.5,'markerfacecolor','black','markeredgecolor','black')

grid on
set(gca, 'gridlinestyle', '-');

axis([0 1 0 1 0 1])
set(gca, 'xtick', 0:0.1:1);
set(gca, 'ytick', 0:0.1:1);
set(gca, 'ztick', 0:0.25:1);

set(gca, 'xtickLabel', {'0','','0.2','','0.4','','0.6','','0.8','','1'}, 'FontSize', 10,'FontName','Ariel'); 
set(gca, 'ytickLabel', {'0','','0.2','','0.4','','0.6','','0.8','','1'}, 'FontSize', 10,'FontName','Ariel');
set(gca, 'ztickLabel', {'0','','0.5','','1'}, 'FontSize', 10,'FontName','Ariel');

h = get(gca,'zlim');
xlabel('x [mm]', 'FontSize', 10, 'position', [0.5 -0.25 h(1)],'FontName','Ariel'); 
ylabel('y [mm]', 'FontSize', 10, 'position', [1.2 0.5 h(1)],'FontName','Ariel');
zlabel('z [mm]','FontSize', 10,'FontName','Ariel');
view(45,60);

set(hFig, 'units', 'centimeters');
hFigposition = get(hFig, 'position');
set(hFig, 'position', [hFigposition(1) hFigposition(2) 8.5 hFigposition(4)*8.5/hFigposition(3)])